#include <iostream>
#include <iomanip> 
#include <math.h>
#include "COMMOD.h"
#include "Helper.h"
#include "ANNEAL.h"
#include<mpi.h>
#include<omp.h>
#include "Output.h"

using namespace std;
using std::string;

ANNEAL* ANNEAL::g_singleton = NULL;

void ANNEAL::RunIt(int NUMBERPROCESS, int MYID)
{
	int C = 1;

	if(0==MYID)
		cout <<"process["<< MYID << "] enter anneal." << endl;

	double DELTA=0.0;

	double U=0.0, OUTER = 0.0;
	int IRANK=0, JRANK=0, LAST=0, NCTR=0, FIXM=0, NABRM=0;
	int I=0, L=0, X=0, NCT=0;

	int INISCOR=0, ISMSCOR=0, ISQSCOR=0, ISHSCOR=0, ITSSCOR=0, INGSCOR=0;
	int BSTSCOR=0, AUTSCOR=0;
	double PCT=0.0;
	int siz = 0;

	string SCORE;

	int horiz=0, vert=900, div=0;
	bool rndf=true, stepf, aimf, redf, trjf, algf, rlxf, rngf, hilf, s45f, s67f, s89f;

	COMMOD* COMMOD9 = COMMOD::Singleton();


	COMMOD9->UU = 0.0;	

	if ((COMMOD9->AUTF == 0) && (COMMOD9->CONTF == 0))
	{
		COMMOD9->BSTPEN = 0.0;
		COMMOD9->BS2PEN = 0.0;
	}

	COMMOD9->TOOPEN = 0.0;
	COMMOD9->TO2PEN = 0.0;
	COMMOD9->TSPEN = 0.0;
	COMMOD9->SMPEN = 0.0;
	COMMOD9->SHPEN = 0.0;
	COMMOD9->CRTPEN = 0.0;
	COMMOD9->NEWRANK = 0;
	//NEWRANK is the rank to which the last (BIG|SML) mutation moved an event

	stepf = false;
	if ((COMMOD9->STEPSOL.substr(0, 3) != "OFF") && (COMMOD9->STEPSOL.substr(0, 3) != "off"))
	{
		stepf = true;
	}

	aimf = false;
	if ((COMMOD9->SOLVEF == 3) && (COMMOD9->FIXF == 2)) aimf = true;

	rngf = false;
	if ((COMMOD9->RUNGRF == 2) || (COMMOD9->RUNGRF == 5)) rngf = true;

	trjf = false;
	if (((COMMOD9->RUNGRF == 2) || (COMMOD9->RUNGRF == 0)) && (COMMOD9->TRJGRF > 0)) trjf = true;

	redf = false;
	if (trjf)
	{
		if ((COMMOD9->RUNGRF != 0) && (COMMOD9->SOLVEF != 2) && (COMMOD9->SOLVEF != 4) &&
				(COMMOD9->SOLVEF != 6) && (COMMOD9->SOLVEF != 8)) redf = true;
	}

	algf = false;
	if ((COMMOD9->SOLVEF == 2) || (COMMOD9->SOLVEF == 4) || (COMMOD9->SOLVEF == 6) ||
			(COMMOD9->SOLVEF == 8)) algf = true;

	rlxf = false;
	if ((COMMOD9->RUNGRF >= 4) || (COMMOD9->GRIDF == 1)) rlxf = true;

	hilf = false;
	if ((COMMOD9->SOLVEF != 2) && (COMMOD9->TRJGRF >= 3)) hilf = true;

	s45f = false;
	if ((COMMOD9->SOLVEF == 4) || (COMMOD9->SOLVEF == 5)) s45f = true;

	s67f = false;
	if ((COMMOD9->SOLVEF == 6) || (COMMOD9->SOLVEF == 7)) s67f = true;

	s89f = false;
	if ((COMMOD9->SOLVEF == 8) || (COMMOD9->SOLVEF == 9)) s89f = true;


	NCTR = 0;
	COMMOD9->CTRF = 0;
	COMMOD9->NBETR = 0;

	if (COMMOD9->CONTF == 1) goto Label111;

	switch (COMMOD9->AUTF)
	{
		case 0:		
			COMMOD9->T = COMMOD9->STARTT;
			break;
		case 1:		
			COMMOD9->Rx = COMMOD9->R;
			break;
		case -1:		
			COMMOD9->Rx = COMMOD9->R;
			if ((COMMOD9->ADAF == 1) && (COMMOD9->NTRIES > 0) && (COMMOD9->LSTRIES > 1))
			{
				L=(rand() % (min(COMMOD9->LSTRIES, 5)+1));			
				COMMOD9->Rx = pow(COMMOD9->R, L);
				COMMOD9->NTRIES = COMMOD9->NTRIES + (L - 1);
			}

			COMMOD9->T = COMMOD9->T * COMMOD9->Rx;

			break;
	}

Label111:
	PCT = COMMOD9->NINNER * COMMOD9->NOUTER;

	int tempPenf = COMMOD9->PENF;
	if (COMMOD9->PENF <= 1)
	{		
		COMMOD9->PENF = 0;
		::GETPEN_WITH_TWOPEN(COMMOD9->INIPERM, COMMOD9->NXTPEN);
		COMMOD9->PENF = tempPenf;
	}
	else if (COMMOD9->PENF >= 2)
	{
		::DEMPEN(COMMOD9->INIPERM, COMMOD9->NXTPEN);
	}

	::CopyArray(COMMOD9->INIPERM,COMMOD9->NEVNT,COMMOD9->PERM);
	::CopyArray(COMMOD9->INIPERM,COMMOD9->NEVNT, COMMOD9->LSTPERM);
	::CopyArray(COMMOD9->INIPERM,COMMOD9->NEVNT, COMMOD9->PXLPERM);

	if (COMMOD9->CONTF == 0) ::CopyArray(COMMOD9->INIPERM,COMMOD9->NEVNT,COMMOD9->BSTPERM);

	COMMOD9->PEN = COMMOD9->NXTPEN;
	COMMOD9->INIPEN = COMMOD9->NXTPEN;
	INISCOR = (int)COMMOD9->INIPEN;
	AUTSCOR = (int)COMMOD9->NXTPEN;

	if (COMMOD9->AUTF == 0)
	{
		if (COMMOD9->CONTF == 0) COMMOD9->BSTPEN = COMMOD9->NXTPEN;
	}
	else
	{
		if (COMMOD9->CONTF == 0) COMMOD9->BSTPEN = COMMOD9->AUTPEN;
	}

	BSTSCOR = (int)COMMOD9->BSTPEN;	

	COMMOD9->NGTPEN = COMMOD9->NGHPEN;
	INGSCOR = (int)COMMOD9->NGTPEN;

	if ((COMMOD9->AUTF == 0) && (COMMOD9->CONTF == 0))
	{
		COMMOD9->BS2PEN = COMMOD9->TOOPEN;
		COMMOD9->SQBST = COMMOD9->SQPEN;
		COMMOD9->SHBST = COMMOD9->SHPEN;
		COMMOD9->TSBST = COMMOD9->TSPEN;
	}

	ISQSCOR = (int)COMMOD9->SQPEN;
	ISHSCOR = (int)COMMOD9->SHPEN;
	COMMOD9->TSLST = COMMOD9->TSPEN;
	ITSSCOR = (int)COMMOD9->TSPEN;

	ISMSCOR = (int)COMMOD9->SMPEN;

	if ((COMMOD9->KSM > 0.0) && (COMMOD9->PENF < 2))
	{
		ISMSCOR = (int)(COMMOD9->SMPEN / COMMOD9->KSM);
		INISCOR = (int)(COMMOD9->PEN - COMMOD9->SMPEN);
		BSTSCOR = (int)(COMMOD9->BSTPEN - COMMOD9->SMPEN);
	}

	if (COMMOD9->CTRF == 1)
	{
		NCT = NCT + 1;
		COMMOD9->CTRF = 0;
	}

	if (COMMOD9->GRID2F == 1)
	{
		//nothing		
	}


	::CopyArray(COMMOD9->HSCTSOL, COMMOD9->SCTSOL_SIZE, COMMOD9->SCTSOL);
	::CopyArray(COMMOD9->COLPEN,COMMOD9->NSCT,COMMOD9->SCJPEN);
	LAST = 1;
	COMMOD9->XPOSN = 0;

	if (COMMOD9->FIXF == 3)
	{
		for (COMMOD9->XPOSN = 0; COMMOD9->XPOSN < COMMOD9->NEVNT; COMMOD9->XPOSN++)
		{
			if (COMMOD9->PERM[COMMOD9->XPOSN] == COMMOD9->XEVNT) break;
		}
	}


	COMMOD9->CONTF = 0;

	//*******************************************************************
	//  MAIN LOOPS
	//     The following lines are executed with every trial!!
	//     Analyse a big sequence of neighbors ('permutations').
	//     Compute the penalty and decide whether to accept the new perm
	//     according to the SOLVER option
	//*******************************************************************

	FIXM = COMMOD9->FIXF;
	NABRM = COMMOD9->NABRGEN;

	long count = 0;	
	int * before;
	int * obj;
	int * from;
	int * to;
	bool * used;
	bool * moved;
	int ** connect;
	int iter = 1;
	int times = C / iter;

	int first = 0;
	int last =0;
	int it =0;	

	before = new int[COMMOD9->NEVNT];
	SetVal(before, COMMOD9->NEVNT, 0);

	obj = new int[NUMBERPROCESS * times];
	SetVal(obj, NUMBERPROCESS * times, 0);

	from = new int[NUMBERPROCESS * times];
	SetVal(from, NUMBERPROCESS * times, 0);

	to = new int[NUMBERPROCESS * times];
	SetVal(to, NUMBERPROCESS * times, 0);

	used = new bool[COMMOD9->NEVNT * times];
	SetVal(used, COMMOD9->NEVNT * times, false);

	moved = new bool[COMMOD9->NEVNT * times];
	SetVal(moved, COMMOD9->NEVNT * times, false);


	int acceptCount = 0;

	MPI_Bcast(COMMOD9->PERM, COMMOD9->NEVNT, MPI_INT, 0, MPI_COMM_WORLD);
	CopyArray(COMMOD9->PERM, COMMOD9->NEVNT, before);


	connect = new int*[COMMOD9->NEVNT];

	for (int i = 0; i < COMMOD9->NEVNT; i++) {
		connect[i] = new int[2];
	}

	connect[COMMOD9->PERM[0]][0] = -1;
	connect[COMMOD9->PERM[COMMOD9->NEVNT - 1]][1] = -1;

	for (int i = 1; i < COMMOD9->NEVNT; i++) {
		connect[COMMOD9->PERM[i]][0] = COMMOD9->PERM[i - 1];
		connect[COMMOD9->PERM[i - 1]][1] = COMMOD9->PERM[i];

	}

	int OuterNumber = 0, InnerNumber = 0;
	COMMOD9->HSCTSOL_CHANGE_FLAG = 0;

	COMMOD9->HSCTSOL_STATE = new int[COMMOD9->NSCT];
	memset(COMMOD9->HSCTSOL_STATE, 0, sizeof(int)*COMMOD9->NSCT);

	COMMOD9->HSCTSOL_LASTPOSITION = new int[COMMOD9->NSCT];
	memset(COMMOD9->HSCTSOL_LASTPOSITION, -1, sizeof(int)*COMMOD9->NSCT);

	COMMOD9->HSCTSOL_LASTVALUE = new int[COMMOD9->NSCT];
	memset(COMMOD9->HSCTSOL_LASTVALUE, 0, sizeof(int)*COMMOD9->NSCT);

	double pen = 0.0;

	for (long INNER = MYID; INNER < COMMOD9->NINNER*COMMOD9->NOUTER; INNER += NUMBERPROCESS)//*****START THE LOOP*********
	{
		PCT = PCT - NUMBERPROCESS;						
		COMMOD9->TSLST = COMMOD9->TSPEN;

		if (MYID > 0) {
			::GONABR(IRANK, JRANK, count, last, first, iter); //GENERATE A NEIGHBOR AS A CANDIDATE PERMUTATION
		}

		last = JRANK;

		if (COMMOD9->PENF <= 1)
		{
			::GETPEN_WITH_TWOPEN(COMMOD9->PERM, COMMOD9->NXTPEN);
		}
		else if (COMMOD9->PENF >= 2)
		{
			::NWDMPEN(IRANK, JRANK, COMMOD9->PERM, COMMOD9->NXTPEN);
		}
		if (MYID == 0) {
			pen = COMMOD9->NXTPEN;
		}

		MPI_Barrier(MPI_COMM_WORLD);

		MPI_Bcast(&pen, 1, MPI_DOUBLE, 0, MPI_COMM_WORLD);

		COMMOD9->UU = ::random(0, 1);			
		DELTA = COMMOD9->NXTPEN - pen;
		COMMOD9->CRTPEN = pen - (COMMOD9->T * log(COMMOD9->UU));
		count++;

		LAST = 0;
		if ((DELTA < 0.0) ||
				((DELTA == 0.0) && ((COMMOD9->SOLVEF < 2) ||
					((s89f) && (COMMOD9->TSPEN <= COMMOD9->TSBST)) ||
					((s67f) && (COMMOD9->SHPEN <= COMMOD9->SHBST)) ||
					((s45f) && (COMMOD9->SQPEN <= COMMOD9->SQBST)))))
		{
			if (COMMOD9->CTRF == 1)
			{
				NCT = NCT + 1;
				COMMOD9->CTRF = 0;
			}
			COMMOD9->PEN = COMMOD9->NXTPEN;
			COMMOD9->ASPNPEN = COMMOD9->SPANPEN;
			::DOTOO();
			if (COMMOD9->PENF < 2)
			{
				COMMOD9->HSCTSOL_CHANGE_FLAG = 0;
				memset(COMMOD9->HSCTSOL_STATE, 0, sizeof(int)*COMMOD9->NSCT);
				memset(COMMOD9->HSCTSOL_LASTPOSITION, -1, sizeof(int)*COMMOD9->NSCT);
			}
			::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);
			LAST = 1;
			if ((COMMOD9->PEN < COMMOD9->BSTPEN) || ((COMMOD9->PEN == COMMOD9->BSTPEN) &&
						(((s89f) && (COMMOD9->TSPEN < COMMOD9->TSBST)) ||
						 ((s67f) && (COMMOD9->SHPEN < COMMOD9->SHBST)) ||
						 ((s45f) && (COMMOD9->SQPEN < COMMOD9->SQBST)))))
			{
				siz = 2;
				if (COMMOD9->PEN == COMMOD9->BSTPEN) siz = 1;
				COMMOD9->SQBST = COMMOD9->SQPEN;
				COMMOD9->SHBST = COMMOD9->SHPEN;
				COMMOD9->TSBST = COMMOD9->TSPEN;
				COMMOD9->BSTPEN = COMMOD9->PEN;
				COMMOD9->NBETR = COMMOD9->NBETR + 1;
				COMMOD9->BS2PEN = COMMOD9->TOOPEN;
				COMMOD9->NGTPEN = COMMOD9->NGHPEN;
				BSTSCOR = (int)COMMOD9->BSTPEN;
				if ((COMMOD9->KSM > 0.00) && (COMMOD9->PENF < 2)) BSTSCOR = BSTSCOR - (int)COMMOD9->SMPEN;
				::CopyArray(COMMOD9->PERM, COMMOD9->NEVNT, COMMOD9->BSTPERM);
			}

		}
		else
		{				
			if (COMMOD9->NUDGER)
			{
				COMMOD9->NUDGUP = false;
				COMMOD9->NUDGDN = false;
			}

			if (algf)
			{
				cout << "algf" << endl;
				::CopyArray(COMMOD9->LSTPERM, COMMOD9->NEVNT, COMMOD9->PERM);
				COMMOD9->TSPEN = COMMOD9->TSLST;
			}
			else
			{
				switch (COMMOD9->SOLVEF)
				{
					case 1:
					case 2:
					case 3:
					case 4:
					case 6:
					case 8:
						break;
					case 5:
						if (COMMOD9->SQPEN > 0)
							U = U * (COMMOD9->SQPEN / COMMOD9->SQBST)*(COMMOD9->SQPEN / COMMOD9->SQBST);
						break;
					case 7:
						if (COMMOD9->SHPEN > 0)
							U = U * (COMMOD9->SHPEN / COMMOD9->SHBST)*(COMMOD9->SHPEN / COMMOD9->SHBST);
						break;
					case 9:
						if (COMMOD9->TSPEN > 0)
							U = U * pow((COMMOD9->TSPEN / COMMOD9->TSBST), 2);
						break;
				}
				if (COMMOD9->NXTPEN < COMMOD9->CRTPEN)
				{
					if (COMMOD9->CTRF == 1)
					{
						NCT = NCT + 1;
						COMMOD9->CTRF = 0;
					}
					switch (COMMOD9->SOLVEF)
					{
						case 1:
						case 2:
						case 3:
						case 4:
						case 6:
						case 8:
							break;
						case 5:
							COMMOD9->SQBST = COMMOD9->SQPEN;
							break;
						case 7:
							COMMOD9->SHBST = COMMOD9->SHPEN;
							break;
						case 9:
							COMMOD9->TSBST = COMMOD9->TSPEN;
							break;
					}
					COMMOD9->PEN = COMMOD9->NXTPEN;
					COMMOD9->ASPNPEN = COMMOD9->SPANPEN;
					::DOTOO();
					if (COMMOD9->PENF < 2)
					{
						::CopyArray(COMMOD9->HSCTSOL, COMMOD9->SCTSOL_SIZE, COMMOD9->SCTSOL);							
						COMMOD9->HSCTSOL_CHANGE_FLAG = 0;
						memset(COMMOD9->HSCTSOL_STATE, 0, sizeof(int)*COMMOD9->NSCT);
						memset(COMMOD9->HSCTSOL_LASTPOSITION, -1, sizeof(int)*COMMOD9->NSCT);
					}
					::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);
					LAST = 1;
					if (rlxf)
					{
						//nothing
					}

				}
				else
				{
					::CopyArray(COMMOD9->LSTPERM, COMMOD9->NEVNT, COMMOD9->PERM);
					last = IRANK;
					COMMOD9->TSPEN = COMMOD9->TSLST;
					COMMOD9->CTRF = 0;
					COMMOD9->HSCTSOL_CHANGE_FLAG = 1;
				}
			}
			COMMOD9->HSCTSOL_CHANGE_FLAG = 1;
		}

		it = COMMOD9->PERM[last];

		if (COMMOD9->SOLVEF == 3) COMMOD9->T = COMMOD9->T * COMMOD9->R;


		MPI_Gather(&first, times, MPI_INT, from, times, MPI_INT, 0, MPI_COMM_WORLD);
		MPI_Gather(&last, times, MPI_INT, to, times, MPI_INT, 0, MPI_COMM_WORLD);
		MPI_Gather(&it, times, MPI_INT, obj, times, MPI_INT, 0, MPI_COMM_WORLD);

		if (MYID == 0) {

			for (int i = 1; i < NUMBERPROCESS; i++) {
				if (from[i] != to[i]) {
					used[obj[i]] = true;
				}
			}

			for (int i = 1; i < NUMBERPROCESS; i++) {

				if (from[i] != to[i] && !moved[obj[i]]) {
					acceptCount++;
					int j = 0;

					int ileft = connect[obj[i]][0];
					int iright = connect[obj[i]][1];

					if (from[i] < to[i]) {							

						int jleft = before[to[i]];
						int jright = connect[jleft][1];

						if (used[jleft]) { continue; }

						if (ileft > -1) {
							connect[ileft][1] = iright;
						}
						if (iright > -1) {
							connect[iright][0] = ileft;
						}

						connect[obj[i]][0] = jleft;
						connect[obj[i]][1] = jright;
						connect[jleft][1] = obj[i];
						if (jright > -1) {
							connect[jright][0] = obj[i];
						}
						moved[obj[i]] = true;
					}
					else if (from[i] > to[i]) {

						int jright = before[to[i]];
						int jleft = connect[jright][0];

						if (used[jright]) { continue; }

						if (ileft > -1) {
							connect[ileft][1] = iright;
						}
						if (iright > -1) {
							connect[iright][0] = ileft;
						}

						connect[obj[i]][0] = jleft;
						connect[obj[i]][1] = jright;
						connect[jright][0] = obj[i];
						if (jleft > -1) {
							connect[jleft][1] = obj[i];
						}
						moved[obj[i]] = true;
					}
				}
			}

			int start;
			for (int i = 0; i < COMMOD9->NEVNT; i++) {
				if (connect[i][0] == -1) {
					start = i;						
					break;
				}
			}


			for (int i = 0; i < COMMOD9->NEVNT; i++) {					
				COMMOD9->PERM[i] = start;
				start = connect[start][1];
			}

			for (int i = 1; i < NUMBERPROCESS; i++) {
				used[obj[i]] = false;
				moved[obj[i]] = false;
			}

			CopyArray(COMMOD9->PERM, COMMOD9->NEVNT, before);

		}


		MPI_Bcast(COMMOD9->PERM, COMMOD9->NEVNT, MPI_INT, 0, MPI_COMM_WORLD);

		if (0 == (INNER + NUMBERPROCESS - MYID) % COMMOD9->NINNER)
		{

			if (COMMOD9->SOLVEF == 3)
			{

				U = ::random(0, 1);
				COMMOD9->T = COMMOD9->STARTT * PCT / (COMMOD9->NINNER * COMMOD9->NOUTER) * U;
				if (COMMOD9->PENF < 2)
				{						
					::GETPEN_WITH_TWOPEN(COMMOD9->BSTPERM, COMMOD9->PEN);
				}
				else if ((COMMOD9->PENF == 5) || (COMMOD9->PENF == 6))
				{
					::DEMPEN(COMMOD9->BSTPERM, COMMOD9->PEN);
				}
				else if (COMMOD9->PENF > 1)
				{
					::DEMPEN(COMMOD9->BSTPERM, COMMOD9->PEN);
				}
				::CopyArray(COMMOD9->BSTPERM, COMMOD9->NEVNT, COMMOD9->PERM);
				::CopyArray(COMMOD9->HSCTSOL, COMMOD9->SCTSOL_SIZE, COMMOD9->SCTSOL);
				::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);
			}
			else
			{					
				if (COMMOD9->AUTF == 0)
				{
					COMMOD9->T = COMMOD9->T * COMMOD9->R;

				}

			}
			InnerNumber++;
			if (MYID == 0)
			{
				cout<<" Step= " << InnerNumber<<"  BestPEN= " << COMMOD9->BSTPEN << "  Temp= "<< COMMOD9->T << endl;

				Output::STEPOUT(COMMOD9->BSTPERM);
				acceptCount = 0;
			}
		}
	}

	delete[] before;
	delete[] obj;
	delete[] from;
	delete[] to;
	delete[] used;
	delete[] moved;

	for (int i = 0; i < COMMOD9->NEVNT; i++) {
		delete connect[i];
	}
	delete[] connect;


	if ((MYID == 0 && COMMOD9->ANNEALONLY) && (COMMOD9->NOUTER > 0 || COMMOD9->NINNER > 0))
	{
		::GETPEN_WITH_TWOPEN(COMMOD9->BSTPERM, COMMOD9->BSTPEN);	
	}

	if (MYID == 0&&!COMMOD9->ANNEALONLY) {
		COMMOD9->AUTPEN = COMMOD9->BSTPEN;
		COMMOD9->NUDGUP = false;
		COMMOD9->NUDGDN = false;
		COMMOD9->FIXF = FIXM;
		COMMOD9->NABRGEN = NABRM;
		if ((COMMOD9->STEPSOL.substr(0, 3) == "LST") ||
				(COMMOD9->STEPSOL.substr(0, 3) == "lst"))
		{
			if (COMMOD9->CDF != 1) ::STEPOUT(COMMOD9->LSTPERM);
			if (COMMOD9->CDF != 1) ::TRAJOUT();
		}
		LAST = COMMOD9->PENF;
		if ((COMMOD9->PAUSF == 5) && (COMMOD9->NTRIES < COMMOD9->NSTOP - 1))
		{
			COMMOD9->NUDGUP = false;
			COMMOD9->NUDGDN = false;
			goto Label33;
		}
		if (COMMOD9->PENF == 1)
		{
			COMMOD9->PENF = -1;
			::GETPEN_WITH_TWOPEN(COMMOD9->BSTPERM, COMMOD9->RVLPEN);
			if (LAST == -1) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);

			COMMOD9->PENF = 0;
			::GETPEN_WITH_TWOPEN(COMMOD9->BSTPERM, COMMOD9->INTPEN);
			if (LAST == 0) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);

			COMMOD9->PENF = 1;
			::GETPEN_WITH_TWOPEN(COMMOD9->BSTPERM, COMMOD9->LVLPEN);
			if (LAST == 1) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);
		}
		else if (COMMOD9->PENF == 0)
		{
			COMMOD9->PENF = -1;
			CalcEPEN();
			::GETPEN_WITH_TWOPEN(COMMOD9->BSTPERM, COMMOD9->RVLPEN);
			if (LAST == -1) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);

			COMMOD9->PENF = 1;
			CalcEPEN();
			::GETPEN_WITH_TWOPEN(COMMOD9->BSTPERM, COMMOD9->LVLPEN);
			if (LAST == 1) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);

			COMMOD9->PENF = 0;
			CalcEPEN();
			::GETPEN_WITH_TWOPEN(COMMOD9->BSTPERM, COMMOD9->INTPEN);
			if (LAST == 0) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);
		}
		else if (COMMOD9->PENF == -1)
		{
			COMMOD9->PENF = 1;
			::GETPEN_WITH_TWOPEN(COMMOD9->BSTPERM, COMMOD9->LVLPEN);
			if (LAST == 1) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);
			COMMOD9->PENF = 0;
			::GETPEN_WITH_TWOPEN(COMMOD9->BSTPERM, COMMOD9->INTPEN);
			if (LAST == 0) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);
			COMMOD9->PENF = -1;
			::GETPEN_WITH_TWOPEN(COMMOD9->BSTPERM, COMMOD9->RVLPEN);
			if (LAST == -1) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);
		}
		COMMOD9->NGTPEN = COMMOD9->NGHPEN;
		COMMOD9->PENF = 6;
		if (COMMOD9->FB4LF != 0) ::DEMPEN(COMMOD9->BSTPERM, COMMOD9->SEQPEN);
		COMMOD9->PENF = 5;
		::DEMPEN(COMMOD9->BSTPERM, COMMOD9->ROYPEN);
		COMMOD9->PENF = 7;
		::DEMPEN(COMMOD9->BSTPERM, COMMOD9->MOMPEN);
		if (LAST == 7) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);
		COMMOD9->PENF = 4;
		::DEMPEN(COMMOD9->BSTPERM, COMMOD9->RSCPEN);
		if (LAST == 4) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);
		COMMOD9->PENF = 3;
		::DEMPEN(COMMOD9->BSTPERM, COMMOD9->SPTPEN);
		if (LAST == 3) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);
		COMMOD9->PENF = 2;
		::DEMPEN(COMMOD9->BSTPERM, COMMOD9->ORDPEN);
		if (LAST == 2) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);
		if (LAST == 5) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);
		if ((LAST == 6) && (COMMOD9->FB4LF != 0)) ::CopyArray(COMMOD9->COLPEN, COMMOD9->NSCT, COMMOD9->SCJPEN);
		if (LAST > 2)
		{
			COMMOD9->PENF = 0;
			::GETPEN_WITH_TWOPEN(COMMOD9->BSTPERM, COMMOD9->INTPEN);
		}
		COMMOD9->PENF = LAST;
		switch (COMMOD9->PENF)
		{
			case -1://eventual
				COMMOD9->BSTPEN = COMMOD9->RVLPEN;
				break;
			case 0://interval
				COMMOD9->BSTPEN = COMMOD9->INTPEN;
				break;
			case 1://level
				COMMOD9->BSTPEN = COMMOD9->LVLPEN;
				break;
			case 2://ordinal
				COMMOD9->BSTPEN = COMMOD9->ORDPEN;
				break;
			case 3://spatial
				COMMOD9->BSTPEN = COMMOD9->SPTPEN;
				break;
			case 4://rascal/rascer
				COMMOD9->BSTPEN = COMMOD9->RSCPEN;
				break;
			case 5://royal (Coex)
				COMMOD9->BSTPEN = COMMOD9->ROYPEN;
				break;
			case 6://sequel (Fb4L)
				if (COMMOD9->FB4LF != 0) COMMOD9->BSTPEN = COMMOD9->SEQPEN;
				break;
			case 7://momental
				COMMOD9->BSTPEN = COMMOD9->MOMPEN;
				break;
		}

Label33:
		COMMOD9->CTRF = NCTR;
	}

	MPI_Barrier(MPI_COMM_WORLD);
}

